<?php
namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\ClientesNaoFaturadosRelatorioService;
use SM\Traits\TResponse;

class ClientesNaoFaturadosRelatorioController extends SMCrud
{

    use TResponse;

    protected $ClientesNaoFaturadosRelatorioService;

    public function __construct($crudService, $environment, ClientesNaoFaturadosRelatorioService $ClientesNaoFaturadosRelatorioService)
    {
            parent::__construct($crudService, $environment);
            $this->ClientesNaoFaturadosRelatorioService = $ClientesNaoFaturadosRelatorioService;
    }

    public function getClientesNaoFaturadosRelatorio(Request $request)
    {
        try {
            $data = $this->ClientesNaoFaturadosRelatorioService->getClientesNaoFaturadosRelatorio($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
