/******************************** Tabela ENCARGO: Cadastro de Produtos ***************************/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes nas colunas: */
/*            CDCTBLENTREN, CDCTBLSAIDEN da tabela ENCARGO                                     */
/* Objetivo: Gerar um log que vai registrar na tabela Geral de Logs de Operaes as alteraes*/
/*        nos campos da tabela Produto listados  seguir:                                    */
/*            Conta contabil: CDCTBLENTREN                                                  */
/********Conta contabil saida: CDCTBLSAIDEN ************************************************/

CREATE OR REPLACE TRIGGER LOG_GER_ENCARGO
AFTER DELETE OR UPDATE OF CDCTBLENTREN,
                                    CDCTBLSAIDEN,
                                    CDENCARGONFE
ON ENCARGO  FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF DELETING THEN
      V_IDTIPOOPER   := '3';
      V_ITPESQ       := :OLD.CDENCARGO;
      V_DESC         := 'ContaCtblEnt= '       || '' || NVL(:OLD.CDCTBLENTREN,'')||' '||
                        'ContaCtblSaid= '      || '' || NVL(:OLD.CDCTBLSAIDEN,'')||' '||
                        'EncargoNFE= '         || '' || NVL(:OLD.CDENCARGONFE,'');
   ELSE
      IF NVL(:NEW.CDCTBLENTREN, '!') <> NVL(:OLD.CDCTBLENTREN, '!') THEN
         V_DESC  := V_DESC || ' ContaCtblEnt= '  || NVL(:NEW.CDCTBLENTREN,'');
      END IF;
      IF NVL(:NEW.CDCTBLSAIDEN, '!') <> NVL(:OLD.CDCTBLSAIDEN, '!') THEN
         V_DESC  := V_DESC || ' ContaCtblSaid= ' || NVL(:NEW.CDCTBLSAIDEN,'');
      END IF;
      IF NVL(:NEW.CDENCARGONFE, '!') <> NVL(:OLD.CDENCARGONFE, '!') THEN
         V_DESC  := V_DESC || ' EncargoNFE= '    || NVL(:NEW.CDENCARGONFE,'');
      END IF;
      IF UPDATING THEN
         V_ITPESQ := :NEW.CDENCARGO;
         V_IDTIPOOPER := '2';
      ELSE
         V_IDTIPOOPER   := '1';
         V_ITPESQ       := :NEW.CDENCARGO;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   IF NOT V_DESC IS NULL THEN
	   INSERT INTO LOGOPERA
   	   (NMTABELA,
      	 DTOPERACAO,
	       NMRESPOPER,
   	    IDTIPOOPER,
      	 DSOPERACAO,
   	    CDPESQITEM,
	       DSRDMUSUOPER,
      	 DSENDUSUOPER,
	       DSNMUSUOPER,
   	    DSMETUSUOPER,
      	 CDORESPOPER)
	   VALUES
   	   ('ENCARGO',
      	 SYSDATE,
      	 NVL(V_NMOPERADOR,' '),
   	    V_IDTIPOOPER,
	       V_DESC,
      	 V_ITPESQ,
   	    V_DSSERVERRDM,
	       V_DSREMOTEADDR,
      	 V_DSREMOTEHOST,
   	    V_DSSERVMETHOD,
	       V_DSREMOTEOPER);
	END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_ENCARGO','5.30.000'); END;
/
