import { Metadata } from '@zeedhi/core';
import { Button } from '@zeedhi/common';

export class MapaFaturamentoController {
    public currentRow : any = {};

    public openFilter({ component }: any) {
        const filterButton = Metadata.getInstance<Button>(`${component.name}_filterButton`);
        filterButton.click({} as Event, {} as HTMLElement);
    }

    public colorDiferenca({ row }: any) {
        let color;

        if (row.NRPARCNEGOCIO === 0) {
            color = { color: '#000000' };
        } else if (row.NRPARCNEGOCIO < 0) {
            color = { color: '#FF0000' };
        } else if (row.NRPARCNEGOCIO > 0) {
            color = { color: '#008000' };
        }

        return color;
    }

    public colorDesvio({ row }: any) {
        let color;

        if (row.NRPARCNEGOCIO === 100) {
            color = { color: '#000000' };
        } else if (row.NRPARCNEGOCIO < 80) {
            color = { color: '#FF0000' };
        } else if (row.NRPARCNEGOCIO > 200) {
            color = { color: '#FF8000' };
        }

        return color;
    }

    public colunaCinza() {
        return 'coluna-cinza';
    }
}
